<?php

/**************************************************
Program name:	buildsql_tbl_create.inc.php

Author:		Joe Mitchell (jwm@basecoach.com)
		Dan Wilson (phpPgAdmin@acucore.com)
		Dan Wilson

Description:	Builds SQL string from the data entered
		on tbl_create_fieldspage.php
		
Create Date:	6/29/01 

Modified Date(s):	

Notes:
**************************************************/

	unset($sql_query);

	unset($query);

	for ($i = 0; $i < $num_fields_newtable; $i++) {
		if (!empty($field_name[$i])) {
			$query .= "$cfgQuotes$field_name[$i]$cfgQuotes $field_type[$i]";
			if (!empty($field_length[$i])) {
				$query .= " (".stripslashes($field_length[$i]).")";
			}
			if (!empty($field_attribute[$i])) {
				$query .= " $field_attribute[$i]";
			}
			if (!empty($field_default[$i])) {
				$query .= " DEFAULT ".squotes(stripslashes($field_default[$i]));
			}
			if ($fk_field[$i] != "--none--") {
				$query .= " REFERENCES ".stripslashes($fk_field[$i]);
			}

			if (!empty($match_type[$i])) {
				$query .= " ".$match_type[$i];
			}

			if (!empty($on_delete[$i])) {
				$query .= " ON DELETE ".$on_delete[$i];
			}

			if (!empty($on_update[$i])) {
				$query .= " ON UPDATE ".$on_update[$i];
			}

			if (!empty($deferrable_type[$i])) {
				$query .= " ".$deferrable_type[$i];
			}
	
			if (!empty($col_constraint[$i])) {
				$query .= " CHECK (".$col_constraint[$i].")";
			}

			if (!eregi("SERIAL", $field_type[$i])) {
				$query .= " $field_null[$i]";
			}
			$query .= ", \n";
		}
	}

	$query = ereg_replace(", \n$", "", $query);

	if(!isset($primary)) {
		$primary = "";
	}

	for ($i=0;$i<count($field_primary);$i++) {
		#$j = $field_primary[$i];       //DON'T Understand the $j 
		#echo "$cfgQuotes$field_name[$j]$cfgQuotes, ";
		#$primary .= "$cfgQuotes$field_name[$j]$cfgQuotes, ";
		if ($field_primary[$i]) {
			$primary .= "$cfgQuotes$field_name[$i]$cfgQuotes, ";
		}

	}

	$primary = ereg_replace(", $", "", $primary);

	if (count($field_primary) > 0) {
		$primary = ",\n PRIMARY KEY ($primary)";
	}

	if(!isset($index)) {
		$index = "";
	}

	for ($i = 0; $i < count($field_index); $i++) {
		#$j = $field_index[$i];
		if ($field_index[$i]) {
			$index .= "CREATE INDEX $cfgQuotes$table" . "_$field_name[$i]" . "_key$cfgQuotes ON $cfgQuotes$table$cfgQuotes($cfgQuotes$field_name[$i]$cfgQuotes); \n";
		}
	}
	$index = ereg_replace(", $", "", $index);

	if(!isset($unique)) 
		$unique = "";
	for ($i = 0; $i < count($field_unique); $i++) {
		#$j = $field_unique[$i];
		if ($field_unique[$i]) {
			$unique .= "$cfgQuotes$field_name[$i]$cfgQuotes, ";
		}
	}
	$unique = ereg_replace(", $", "", $unique);

	if (count($field_unique) > 0) {
		$unique = ", UNIQUE ($unique)";
	}

	//add table constraint
	$constraintclause .= ", ".$table_constraint;

	$query_keys = $primary.$unique.$constraintclause;
	$query_keys = ereg_replace(", $", "", $query_keys);

	$sql_query = "CREATE TABLE $cfgQuotes$table$cfgQuotes (\n".$query." ".$query_keys.");\n";

	if (!empty($index)) {
		$sql_query .= $index;
	}


?>
