<?php

/**************************************************
Program name:	get_array_types.inc.php

Author:		Joe Mitchell (jwm@basecoach.com)
		Dan Wilson (phpPgAdmin@acucore.com)

Description:	Get array of data types.
			
Create Date:	6/29/01 

Modified Date(s):	
**************************************************/

// SQL string to get list of data types
$sql_get = "
		SELECT typname 
		FROM pg_type pt
		WHERE typname NOT LIKE '\\\_%' AND typrelid = 0
		ORDER BY typname
	";

// Connect and Execute the SQL statement ($sql_get)
include($PATH_INCLUDE."connect_exec.inc.php");


// Modify 
unset($aryTypes);
for ($i = 0; $i < $num_rows; $i++) {
	$aryTypes[$i] = $sql_array[$i][typname];
}

// NOTE:  select_box() need single-dimension associated array

// add SERIAL type since it's "not" a type.

if (count($aryTypes) > 0) {
	# next id is count sine zero-base.
	$serial_type_id = count($aryTypes);
	$aryTypes[$serial_type_id] = "SERIAL";

// add OPAQUE type 
	$opaqueid = $serial_type_id + 1;
	$aryTypes[$opaqueid] = "OPAQUE";
}

?>

